var router = require('koa-router')();
var moralis = require('../model/moralis_sdk.js')
var utils = require('../model/utils.js');

router.prefix('/sdk');

/**
 * 获取代币价格
 * @param {*} ctx 
 */
async function getAllTotkenPrice(ctx) {
    console.log("body", typeof (ctx.request.body), ctx);
    const obj = ctx.request.body;
    console.log("obj", obj);
    if (obj.address != null && obj.chain != null) {
        await moralis.getTotkenPrice(obj.address, obj.chain).then((result) => {
            console.log('getTotkenPrice result:', result)
            ctx.body = result;
        })
    } else {
        ctx.body = utils.toJson(-1, null, "please check address or chain parameter is ok ? ");
    }
}

/**
 * 获取交易记录
 * @param {*} ctx 
 */
async function getTransfers(ctx) {
    console.log("body", ctx);
    const obj = ctx.request.body;
    console.log("obj", obj);
    if (!obj.chain)//默认 bsc 币安链
        obj.chain = 'bsc'
    await moralis.getTokenTransfers(obj).then((result) => {
        ctx.body = result;
    })
}

/**
 * 出金，入金交易
 * @param {*} ctx 
 * @returns 
 */
async function transfer(ctx) {
    if (ctx.request == null || ctx.request.body == null) {
        ctx.body = utils.toJson(-1, null, "request error. ");
        return
    }
    const obj = ctx.request.body;
    await moralis.transfer(obj).then((result) => {
        ctx.body = result;
    });
}

async function getAllTokenWithdrawInfoLists(ctx) {
    if (ctx.request == null || ctx.request.body == null) {
        ctx.body = utils.toJson(-1, null, "request error. ");
        return
    }
    ctx.body = await moralis.getAllTokenWithdrawInfoLists(ctx);
}

//获取交易记录
router.post('/getTransfers', getTransfers)
// 获取所有代币价格
router.post('/getAllTotkenPrice', getAllTotkenPrice)
//归集 and 提现
router.post('/transfer', transfer)
//获取所有地址的所要消耗的最低提取费
router.post('/getAllTokenWithdrawInfoLists', getAllTokenWithdrawInfoLists)

async function crypto_test(ctx) {
    if (ctx.request == null || ctx.request.body == null) {
        ctx.body = utils.toJson(-1, null, "request error. ");
        return;
    }

    const obj = ctx.request.body;
    var crypt_key = obj.key;
    var message = obj.privateKey;

    //process.env.NODE_ENV
    console.log("NDK_HOME", process.env.NDK_HOME);

    utils.decryptPrivityKey(crypt_key,message);

    console.log("decrypt message:", message);

    ctx.body = {
        decrypt: message
    }
}
router.post('/crypto_test', crypto_test)

module.exports = router;
